package text

import (
	tgbotapi "github.com/go-telegram-bot-api/telegram-bot-api/v5"
	"log"
	"regexp"
	"strings"
	"time"
	"watn3y/bloaterbotv3/commonlogic"
	"watn3y/bloaterbotv3/config"
	"watn3y/bloaterbotv3/text/balonlyl"
	"watn3y/bloaterbotv3/text/nhentai"
)

func Matcher(update tgbotapi.Update, bot *tgbotapi.BotAPI) {
	if time.Since(config.BotConfig.Shutup[update.Message.Chat.ID]) <= time.Minute {
		return
	}

	//nhentai
	const nhentaiRegex string = "([ \\t\\n\\r]|^)\\d{2,}([ \\t\\n\\r]|$)"
	isNhentai, err := regexp.MatchString(nhentaiRegex, update.Message.Text)
	if err != nil {
		log.Panicf("Failed to compile regex for nhentai", err)
	}
	if isNhentai && (commonlogic.ContainsInt64(config.BotConfig.Nhentai.EnabledChats, update.Message.Chat.ID) || update.Message.From.ID == update.Message.Chat.ID) {
		go nhentai.Nhentai(nhentaiRegex, update, bot)
	}

	//balonlyl
	var isBalonlyl bool = false
	for _, word := range config.BotConfig.Balonlyl.TriggerWords {
		if strings.Contains(strings.ToLower(update.Message.Text), word) && (commonlogic.ContainsInt64(config.BotConfig.Balonlyl.EnabledChats, update.Message.Chat.ID) || update.Message.From.ID == update.Message.Chat.ID) {
			isBalonlyl = true
			break
		}
	}
	if isBalonlyl {
		go balonlyl.Balonlyl(update, bot)
	}

}
